<?php
class DATAClass {
	var $f;
	var $mode; // 1 - File; 0 - Echo
	var $index = 0;

	function open($filepath, $mode = 1, $filesize = 0) {
		$this->mode = $mode;
		$this->index = 0;
		if ($mode == 1) {
			$this->f = fopen($filepath, "w");
		} else {
			ob_end_clean();
			ob_start("ob_gzhandler", 9);

			header("HTTP/1.1 200 OK");
			header("Content-Transfer-Encoding: Binary");
			header("Content-Type: application/octet-stream");
		      //header('Content-Disposition: attachment; filename="'.$filepath.'"');
			header('Content-Disposition: inline; filename="'.$filepath.'"');
			if ($filesize) {
				header("Content-Length: $filesize");
			}
		}
	}

	function write($data) {
		$this->index += strlen($data);
		if ($this->mode == 1) {
			$writed_length = fwrite($this->f, $data);
			return $writed_length;
		} else {
			echo $data;
		}
	}

	function close() {
		if ($this->mode == 1) {
			fclose($this->f);
		}
	}

	function tell() {
		return $this->index;
	}

	function error($text, $close = true) {
		if ($close == true) $this->close();
		die($text);
	}
}
?>