<?php
class FILEClass {
	var $f;
	var $mode = "";
	var $index = 0;
	var $isfile = True;
	var $file_size = 0;
	var $file_name = "";
	var $file_path = "";
	var $file_parts = Array();
	var $part_index = 0;

	function open($filepath, $mode = "r") {
		$this->mode = $mode;
		$this->index = 0;
		$this->file_size = 0;
		$this->file_path = str_replace("\\", "/", $filepath);

		$temp = explode("/", $this->file_path);
		$this->file_name = $temp[count($temp)-1];
		unset($temp);

		$return = True;

		if (is_file($this->file_path)) {
			$this->isfile = True;
			if ($this->f = fopen($this->file_path, $this->mode)) {
				$this->file_size = filesize($this->file_path);
			} else {
				$return = False;
			}
		} else {
			$this->isfile = False;
			$p = 0;
			if ($open = @opendir($this->file_path)) {
				for($i=0;($file = readdir($open)) != false;$i++){
					if (is_file($this->file_path."/".$file) && substr($file, 0, strlen($this->file_name)) == $this->file_name && $file != "." && $file != "..") {
						$this->file_parts[$p] = Array();
						$this->file_parts[$p]['path'] = $this->file_path."/".$file;
						$this->file_parts[$p]['size'] = filesize($this->file_path."/".$file);
						$this->file_parts[$p]['index'] = $this->file_size;
						$this->file_size += $this->file_parts[$p]['size'];
						$this->file_parts[$p]['end'] = $this->file_size;
						$p++;
					}
				}
			} else {
				$return = False;
			}
			if ($this->f = fopen($this->file_parts[0]['path'], $this->mode)) {
				$this->part_index = 0;
			} else {
				$return = False;
			}
		}
		return $return;
	}

	function read($length) {
		// For no errors
		if ($length < 0) { return ""; }
		if ($length > ($this->file_size-$this->index)) { $length = ($this->file_size-$this->index); }

		if ($this->isfile == False) {
			$data = "";
			while($length > 0) {
				if ($length > ($this->file_parts[$this->part_index]['end'] - $this->index)) {
					$data .= fread($this->f, $this->file_parts[$this->part_index]['end'] - $this->index);
					$length -= $this->file_parts[$this->part_index]['end'] - $this->index;
					fclose($this->f);
					$this->part_index++;
					$this->f = fopen($this->file_parts[$this->part_index]['path'], $this->mode);
					$this->index = $this->file_parts[$this->part_index]['index'];
				} else {
					$data .= fread($this->f, $length);
					$this->index = $this->file_parts[$this->part_index]['index'] + $length;
					break;
				}
			}
		} else {
			$data .= fread($this->f, $length);
			$this->index += $length;
		}
		return $data;
	}

	function seek($seek_index) {
		// For no errors
		if ($seek_index < 0) { $seek_index = 0; }
		if ($seek_index > $this->file_size) { $seek_index = $this->file_size; }
		
		if ($this->isfile == False) {
			$open = False;
			if ($seek_index <= $this->file_parts[$this->part_index]['index']) {
				fclose($this->f);
				$open = True;
				while ($seek_index < $this->file_parts[$this->part_index]['index']) {
					$this->part_index--;
				}
			} elseif ($seek_index >= $this->file_parts[$this->part_index]['end']) {
				fclose($this->f);
				$open = True;
				while ($seek_index > $this->file_parts[$this->part_index]['end']) {
					$this->part_index++;
				}
			}
			if ($open == True) {
				$this->f = fopen($this->file_parts[$this->part_index]['path'], $this->mode);
			}
			fseek($this->f, $seek_index - $this->file_parts[$this->part_index]['index']);
		} else {
			fseek($this->f, $seek_index);
		}
		$this->index = $seek_index;
	}
	
	function tell() {
		return $this->index;
	}

	function close() {
		fclose($this->f);
	}

	function error($text, $close = true) {
		if ($close == true) $this->close();
		die($text);
	}
}
?>